<template>
  <q-page padding>
    <iframe v-if="channel && channel.dashboard_embed_url" :src="channel.dashboard_embed_url"
      frameborder="0" allowfullscreen
      style="border: 0; width: 100%; height: 100%;"
      class="absolute-full"
      @load="iframeLoaded = true"
    >
    </iframe>
    <div v-else-if="channel && channel.dashboard_url" class="row justify-center">
      <q-btn size="lg" @click="openURL(channel.dashboard_url)" color="primary">
        Dive into Analytics
      </q-btn>
    </div>
    <div v-else class="q-headline">No analytics defined</div>
    <q-inner-loading :visible="!iframeLoaded && channel && typeof channel.dashboard_embed_url === 'string' && channel.dashboard_embed_url.length > 0" />
  </q-page>
</template>

<script>
  import { openURL } from 'quasar';
  import { CancelToken, isCancel } from 'axios';
  import { showRejectionMessage } from '../../utils';

  export default {
    name: 'irwAnalytics',
    data() {
      return {
        channel: {},
        iframeLoaded: false,
      };
    },
    computed: {
      location: {
        get() {
          return this.$store.state.location.location;
        },
      },
    },
    methods: {
      openURL,
      load() {
        if (!this.location) {
          this.channel = {};
          return false;
        }
        if (this.cancel) this.cancel.cancel();
        this.cancel = CancelToken.source();
        return this.$http
          .get('/channels/list', {
            params: {
              channel_id: this.location.portal_channel_id,
            },
            cancelToken: this.cancel.token,
          })
          .then((response) => {
            this.channel = response.data.results.length ? response.data.results[0] : {};
            return response;
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error reading channel info.');
            }
            this.channel = {};
          });
      },
    },
    watch: {
      'location.portal_channel_id': function load() {
        this.load();
      },
    },
    mounted() {
      this.load();
    },
    beforeDestroy() {
      if (this.cancel) this.cancel.cancel();
    },
  };
</script>
